#import "DiskutilController.h"

@implementation DiskutilController

- (IBAction)beispiel1:(id)sender
{
	[fldResult setStringValue:@""];
	
	NSTask *task = [[NSTask alloc] init];
	[task setLaunchPath:@"/usr/sbin/diskutil"];
	NSArray *params = [NSArray arrayWithObjects:@"verifyDisk", [fldVolume stringValue], nil];
	[task setArguments:params];
	
	[task launch];
	[task waitUntilExit];
	
	int status = [task terminationStatus];
	if (status == ATASK_SUCCESS_VALUE)
		[fldResult setStringValue:[NSString stringWithFormat:@"diskutil verifyDisk %@ erfolgreich beendet.", [fldVolume stringValue]]];
	else
		[fldResult setStringValue:@"Ein Fehler ist aufgetreten!"];
	
	[task release];
}

- (IBAction)beispiel2:(id)sender
{
	[fldResult setStringValue:@""];
	
	NSTask *task = [[NSTask alloc] init];
	[task setLaunchPath:@"/usr/sbin/diskutil"];
	NSArray *params = [NSArray arrayWithObjects:@"verifyDisk", [fldVolume stringValue], nil];
	[task setArguments:params];
	
	NSPipe *pipe = [NSPipe pipe];
	[task setStandardOutput:pipe];
	NSFileHandle *file = [pipe fileHandleForReading];
	
	[task launch];
	[task waitUntilExit];
	
	NSData *data = [file readDataToEndOfFile];
	NSString *result = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
	[fldResult setStringValue:result];
	[result release];
	[task release];
}

- (IBAction)beispiel3:(id)sender
{
	[fldResult setStringValue:@""];
	
	NSTask *task = [[NSTask alloc] init];
	[task setLaunchPath:@"/usr/sbin/diskutil"];
	NSArray *params = [NSArray arrayWithObjects:@"verifyDisk", [fldVolume stringValue], nil];
	[task setArguments:params];
	
	NSPipe *pipe = [NSPipe pipe];
	[task setStandardOutput:pipe];
	NSFileHandle *file = [pipe fileHandleForReading];
	
	[task launch];

	[NSThread detachNewThreadSelector:@selector(readData:) toTarget:self withObject:file];
	
	[task autorelease];
}

- (void)readData:(NSFileHandle *)file
{
    // in einem Thread muss ein AutoreleasePool angelegt werden
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSData *data;
	
	while(data = [file availableData])
	{
		NSString *result=[[NSString alloc] initWithData:data encoding:NSASCIIStringEncoding];
		[fldResult setStringValue:[NSString stringWithFormat:@"%@%@", [fldResult stringValue], result]];
		[result release];
	}
		
	[pool release];
}

@end
